diff -r f40675df5d4c trytond/modules/account/tax.py
--- a/trytond/modules/account/tax.py	Fri Sep 21 15:57:18 2012 +0200
+++ b/trytond/modules/account/tax.py	Mon Sep 24 20:36:38 2012 +0200
@@ -666,14 +621,16 @@
             }, depends=['type'])
     template = fields.Many2One('account.tax.template', 'Template')
 
-    def __init__(self):
-        super(Tax, self).__init__()
-        self._order.insert(0, ('sequence', 'ASC'))
+    @classmethod
+    def __setup__(cls):
+        super(Tax, cls).__setup__()
+        cls._order.insert(0, ('sequence', 'ASC'))
 
-    def init(self, module_name):
-        super(Tax, self).init(module_name)
+    @classmethod
+    def __register__(cls, module_name):
+        super(Tax, cls).__register__(module_name)
         cursor = Transaction().cursor
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
 
         # Migration from 1.0 group is no more required
         table.not_null_action('group', action='remove')
@@ -681,96 +638,78 @@
         # Migration from 2.4: drop required on sequence
         table.not_null_action('sequence', action='remove')
 
-    def default_active(self):
+    @staticmethod
+    def default_active():
         return True
 
-    def default_type(self):
+    @staticmethod
+    def default_type():
         return 'percentage'
 
-    def default_include_base_amount(self):
+    @staticmethod
+    def default_include_base_amount():
         return False
 
-    def default_invoice_base_sign(self):
+    @staticmethod
+    def default_invoice_base_sign():
         return Decimal('1')
 
-    def default_invoice_tax_sign(self):
+    @staticmethod
+    def default_invoice_tax_sign():
         return Decimal('1')
 
-    def default_credit_note_base_sign(self):
+    @staticmethod
+    def default_credit_note_base_sign():
         return Decimal('1')
 
-    def default_credit_note_tax_sign(self):
+    @staticmethod
+    def default_credit_note_tax_sign():
         return Decimal('1')
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
-    def on_change_with_currency_digits(self, vals):
-        company_obj = Pool().get('company.company')
-        if vals.get('company'):
-            company = company_obj.browse(vals['company'])
-            return company.currency.digits
+    def on_change_with_currency_digits(self, name=None):
+        if self.company:
+            return self.company.currency.digits
         return 2
 
-    def get_currency_digits(self, ids, name):
-        res = {}
-        for tax in self.browse(ids):
-            res[tax.id] = tax.company.currency.digits
-        return res
-
-    def _process_tax(self, tax, price_unit):
-        if tax.type == 'percentage':
-            amount = price_unit * tax.percentage / Decimal('100')
+    def _process_tax(self, price_unit):
+        if self.type == 'percentage':
+            amount = price_unit * self.percentage / Decimal('100')
             return {
                 'base': price_unit,
                 'amount': amount,
-                'tax': tax,
-            }
-        if tax.type == 'fixed':
-            amount = tax.amount
+                'tax': self,
+                }
+        if self.type == 'fixed':
+            amount = self.amount
             return {
                 'base': price_unit,
                 'amount': amount,
-                'tax': tax,
-            }
+                'tax': self,
+                }
 
-    def _unit_compute(self, taxes, price_unit):
+    @classmethod
+    def _unit_compute(cls, taxes, price_unit):
         res = []
         for tax in taxes:
             if tax.type != 'none':
-                res.append(self._process_tax(tax, price_unit))
+                res.append(tax._process_tax(price_unit))
             if len(tax.childs):
-                res.extend(self._unit_compute(tax.childs, price_unit))
+                res.extend(cls._unit_compute(tax.childs, price_unit))
         return res
 
-    def delete(self, ids):
-        # Restart the cache
-        self.sort_taxes.reset()
-        return super(Tax, self).delete(ids)
+    @classmethod
+    def sort_taxes(cls, taxes):
+        '''
+        Return a list of taxes sorted
+        '''
+        return sorted(taxes, key=lambda t: (t.sequence, t.id))
 
-    def create(self, vals):
-        # Restart the cache
-        self.sort_taxes.reset()
-        return super(Tax, self).create(vals)
-
-    def write(self, ids, vals):
-        # Restart the cache
-        self.sort_taxes.reset()
-        return super(Tax, self).write(ids, vals)
-
-    @Cache('account_tax.sort_taxes')
-    def sort_taxes(self, ids):
-        '''
-        Return a list of taxe ids sorted
-
-        :param ids: a list of tax ids
-        :return: a list of tax ids sorted
-        '''
-        return self.search([
-            ('id', 'in', ids),
-            ], order=[('sequence', 'ASC'), ('id', 'ASC')])
-
-    def compute(self, ids, price_unit, quantity):
+    @classmethod
+    def compute(cls, taxes, price_unit, quantity):
         '''
         Compute taxes for price_unit and quantity.
         Return list of dict for each taxes and their childs with:
@@ -778,130 +717,118 @@
             amount
             tax
         '''
-        ids = self.sort_taxes(ids)
-        taxes = self.browse(ids)
-        res = self._unit_compute(taxes, price_unit)
+        taxes = cls.sort_taxes(taxes)
+        res = cls._unit_compute(taxes, price_unit)
         quantity = Decimal(str(quantity or 0.0))
         for row in res:
             row['base'] *= quantity
             row['amount'] *= quantity
         return res
 
-    def update_tax(self, tax, template2tax_code, template2account,
+    def update_tax(self, template2tax_code, template2account,
             template2tax=None):
         '''
         Update recursively taxes based on template.
-
-        :param tax: a tax id or the BrowseRecord of the tax
-        :param template2tax_code: a dictionary with tax code template id as key
-                and tax code id as value, used to convert tax code template
-                into tax code
-        :param template2account: a dictionary with account template id as key
-                and account id as value, used to convert account template into
-                account code
-        :param template2tax: a dictionary with tax template id as key and
-                tax id as value, used to convert template id into tax.
-                The dictionary is filled with new taxes
+        template2tax_code is a dictionary with tax code template id as key and
+        tax code id as value, used to convert tax code template into tax code.
+        template2account is a dictionary with account template id as key and
+        account id as value, used to convert account template into account
+        code.
+        template2tax is a dictionary with tax template id as key and tax id as
+        value, used to convert template id into tax.  The dictionary is filled
+        with new taxes.
         '''
-        template_obj = Pool().get('account.tax.template')
-        lang_obj = Pool().get('ir.lang')
+        Lang = Pool().get('ir.lang')
 
         if template2tax is None:
             template2tax = {}
 
-        if isinstance(tax, (int, long)):
-            tax = self.browse(tax)
-
-        if tax.template:
-            vals = template_obj._get_tax_value(tax.template, tax=tax)
-            if (tax.template.invoice_account
-                    and tax.invoice_account.id != template2account.get(
-                        tax.template.invoice_account.id)):
+        if self.template:
+            vals = self.template._get_tax_value(tax=self)
+            if (self.template.invoice_account
+                    and self.invoice_account.id != template2account.get(
+                        self.template.invoice_account.id)):
                 vals['invoice_account'] = template2account.get(
-                    tax.template.invoice_account.id)
-            elif (not tax.template.invoice_account
-                    and tax.invoice_account):
+                    self.template.invoice_account.id)
+            elif (not self.template.invoice_account
+                    and self.invoice_account):
                 vals['invoice_account'] = None
-            if (tax.template.credit_note_account
-                    and tax.credit_note_account.id != template2account.get(
-                        tax.template.credit_note_account.id)):
+            if (self.template.credit_note_account
+                    and self.credit_note_account.id != template2account.get(
+                        self.template.credit_note_account.id)):
                 vals['credit_note_account'] = template2account.get(
-                    tax.template.credit_note_account.id)
-            elif (not tax.template.credit_note_account
-                    and tax.credit_note_account):
+                    self.template.credit_note_account.id)
+            elif (not self.template.credit_note_account
+                    and self.credit_note_account):
                 vals['credit_note_account'] = None
-            if (tax.template.invoice_base_code
-                    and tax.invoice_base_code.id != template2tax_code.get(
-                        tax.template.invoice_base_code.id)):
+            if (self.template.invoice_base_code
+                    and self.invoice_base_code.id != template2tax_code.get(
+                        self.template.invoice_base_code.id)):
                 vals['invoice_base_code'] = template2tax_code.get(
-                    tax.template.invoice_base_code.id)
-            elif (not tax.template.invoice_base_code
-                    and tax.invoice_base_code):
+                    self.template.invoice_base_code.id)
+            elif (not self.template.invoice_base_code
+                    and self.invoice_base_code):
                 vals['invoice_base_code'] = None
-            if (tax.template.invoice_tax_code
-                    and tax.invoice_tax_code.id != template2tax_code.get(
-                        tax.template.invoice_tax_code.id)):
+            if (self.template.invoice_tax_code
+                    and self.invoice_tax_code.id != template2tax_code.get(
+                        self.template.invoice_tax_code.id)):
                 vals['invoice_tax_code'] = template2tax_code.get(
-                    tax.template.invoice_tax_code.id)
-            elif (not tax.template.invoice_tax_code
-                    and tax.invoice_tax_code):
+                    self.template.invoice_tax_code.id)
+            elif (not self.template.invoice_tax_code
+                    and self.invoice_tax_code):
                 vals['invoice_tax_code'] = None
-            if (tax.template.credit_note_base_code
-                    and tax.credit_note_base_code.id != template2tax_code.get(
-                        tax.template.credit_note_base_code.id)):
+            if (self.template.credit_note_base_code
+                    and self.credit_note_base_code.id != template2tax_code.get(
+                        self.template.credit_note_base_code.id)):
                 vals['credit_note_base_code'] = template2tax_code.get(
-                    tax.template.credit_note_base_code.id)
-            elif (not tax.template.credit_note_base_code
-                    and tax.credit_note_base_code):
+                    self.template.credit_note_base_code.id)
+            elif (not self.template.credit_note_base_code
+                    and self.credit_note_base_code):
                 vals['credit_note_base_code'] = None
-            if (tax.template.credit_note_tax_code
-                    and tax.credit_note_tax_code.id != template2tax_code.get(
-                        tax.template.credit_note_tax_code.id)):
+            if (self.template.credit_note_tax_code
+                    and self.credit_note_tax_code.id != template2tax_code.get(
+                        self.template.credit_note_tax_code.id)):
                 vals['credit_note_tax_code'] = template2tax_code.get(
-                    tax.template.credit_note_tax_code.id)
-            elif (not tax.template.credit_note_tax_code
-                    and tax.credit_note_tax_code):
+                    self.template.credit_note_tax_code.id)
+            elif (not self.template.credit_note_tax_code
+                    and self.credit_note_tax_code):
                 vals['credit_note_tax_code'] = None
 
             if vals:
-                self.write(tax.id, vals)
+                self.write([self], vals)
 
-            prev_lang = tax._context.get('language') or CONFIG['language']
+            prev_lang = self._context.get('language') or CONFIG['language']
             prev_data = {}
-            for field_name, field in tax.template._columns.iteritems():
+            for field_name, field in self.template._fields.iteritems():
                 if getattr(field, 'translate', False):
-                    prev_data[field_name] = tax.template[field_name]
-            for lang in lang_obj.get_translatable_languages():
+                    prev_data[field_name] = getattr(self.template, field_name)
+            for lang in Lang.get_translatable_languages():
                 if lang == prev_lang:
                     continue
-                tax.setLang(lang)
-                data = {}
-                for field_name, field in tax.template._columns.iteritems():
-                    if (getattr(field, 'translate', False)
-                            and tax.template[field_name] !=
-                            prev_data[field_name]):
-                        data[field_name] = tax.template[field_name]
-                if data:
-                    with Transaction().set_context(language=lang):
-                        self.write(tax.id, data)
-            tax.setLang(prev_lang)
+                with Transaction().set_context(language=lang):
+                    tax = self.__class__(self.id)
+                    data = {}
+                    for field_name, field in tax.template._fields.iteritems():
+                        if (getattr(field, 'translate', False)
+                                and (getattr(tax.template, field_name)
+                                    != prev_data[field_name])):
+                            data[field_name] = getattr(tax.template,
+                                field_name)
+                    if data:
+                        self.write([tax], data)
             template2tax[tax.template.id] = tax.id
 
         for child in tax.childs:
-            self.update_tax(child, template2tax_code, template2account,
-                    template2tax=template2tax)
+            child.update_tax(template2tax_code, template2account,
+                template2tax=template2tax)
 
-Tax()
 
-
-class Line(ModelSQL, ModelView):
+class TaxLine(ModelSQL, ModelView):
     'Tax Line'
-    _name = 'account.tax.line'
-    _description = __doc__
+    __name__ = 'account.tax.line'
     _rec_name = 'amount'
-
     currency_digits = fields.Function(fields.Integer('Currency Digits',
-        on_change_with=['move_line']), 'get_currency_digits')
+        on_change_with=['move_line']), 'on_change_with_currency_digits')
     amount = fields.Numeric('Amount', digits=(16, Eval('currency_digits', 2)),
         required=True, depends=['currency_digits'])
     code = fields.Many2One('account.tax.code', 'Code', select=True,
@@ -911,109 +838,81 @@
     move_line = fields.Many2One('account.move.line', 'Move Line',
             required=True, select=True, ondelete='CASCADE')
 
-    def on_change_with_currency_digits(self, vals):
-        move_line_obj = Pool().get('account.move.line')
-        if vals.get('move_line'):
-            move_line = move_line_obj.browse(vals['move_line'])
-            return move_line.currency_digits
+    def on_change_with_currency_digits(self, name=None):
+        if self.move_line:
+            return self.move_line.currency_digits
         return 2
 
-    def get_currency_digits(self, ids, name):
-        res = {}
-        for line in self.browse(ids):
-            res[line.id] = line.move_line.currency_digits
-        return res
-
-    def on_change_tax(self, vals):
-        res = {
+    def on_change_tax(self):
+        return {
             'code': None,
             }
-        return res
 
-Line()
 
-
-class RuleTemplate(ModelSQL, ModelView):
+class TaxRuleTemplate(ModelSQL, ModelView):
     'Tax Rule Template'
-    _name = 'account.tax.rule.template'
-    _description = __doc__
+    __name__ = 'account.tax.rule.template'
     name = fields.Char('Name', required=True, translate=True)
     lines = fields.One2Many('account.tax.rule.line.template', 'rule', 'Lines')
     account = fields.Many2One('account.account.template', 'Account Template',
             domain=[('parent', '=', None)], required=True)
 
-    def _get_tax_rule_value(self, template, rule=None):
+    def _get_tax_rule_value(self, rule=None):
         '''
         Set values for tax rule creation.
-
-        :param template: the BrowseRecord of the template
-        :param rule: the BrowseRecord of the rule to update
-        :return: a dictionary with rule fields as key and values as value
         '''
         res = {}
-        if not rule or rule.name != template.name:
-            res['name'] = template.name
-        if not rule or rule.template.id != template.id:
-            res['template'] = template.id
+        if not rule or rule.name != self.name:
+            res['name'] = self.name
+        if not rule or rule.template.id != self.id:
+            res['template'] = self.id
         return res
 
-    def create_rule(self, template, company_id, template2rule=None):
+    def create_rule(self, company_id, template2rule=None):
         '''
         Create tax rule based on template.
-
-        :param template: the template id or the BrowseRecord of template
-                used for tax rule creation
-        :param company_id: the id of the company for which tax rules are
-                created
-        :param template2rule: a dictionary with tax rule template id as key
-                and tax rule id as value, used to convert template id into
-                tax rule. The dictionary is filled with new tax rules
-        :return: id of the tax rule created
+        template2rule is a dictionary with tax rule template id as key and tax
+        rule id as value, used to convert template id into tax rule. The
+        dictionary is filled with new tax rules.
+        Return id of the tax rule created
         '''
-        rule_obj = Pool().get('account.tax.rule')
-        lang_obj = Pool().get('ir.lang')
+        pool = Pool()
+        Rule = pool.get('account.tax.rule')
+        Lang = pool.get('ir.lang')
 
         if template2rule is None:
             template2rule = {}
 
-        if isinstance(template, (int, long)):
-            template = self.browse(template)
+        if self.id not in template2rule:
+            vals = self._get_tax_rule_value()
+            vals['company'] = company_id
+            new_rule = Rule.create(vals)
 
-        if template.id not in template2rule:
-            vals = self._get_tax_rule_value(template)
-            vals['company'] = company_id
-            new_id = rule_obj.create(vals)
-
-            prev_lang = template._context.get('language') or CONFIG['language']
+            prev_lang = self._context.get('language') or CONFIG['language']
             prev_data = {}
-            for field_name, field in template._columns.iteritems():
+            for field_name, field in self._fields.iteritems():
                 if getattr(field, 'translate', False):
-                    prev_data[field_name] = template[field_name]
-            for lang in lang_obj.get_translatable_languages():
+                    prev_data[field_name] = getattr(self, field_name)
+            for lang in Lang.get_translatable_languages():
                 if lang == prev_lang:
                     continue
-                template.setLang(lang)
-                data = {}
-                for field_name, field in template._columns.iteritems():
-                    if getattr(field, 'translate', False) \
-                            and template[field_name] != prev_data[field_name]:
-                        data[field_name] = template[field_name]
-                if data:
-                    with Transaction().set_context(language=lang):
-                        rule_obj.write(new_id, data)
-            template.setLang(prev_lang)
-            template2rule[template.id] = new_id
-        else:
-            new_id = template2rule[template.id]
-        return new_id
+                with Transaction().set_context(language=lang):
+                    template = self.__class__(self.id)
+                    data = {}
+                    for field_name, field in template._fields.iteritems():
+                        if (getattr(field, 'translate', False)
+                                and (getattr(self, field_name)
+                                    != prev_data[field_name])):
+                            data[field_name] = getattr(self, field_name)
+                    if data:
+                        Rule.write([new_rule], data)
+            template2rule[self.id] = new_rule.id
+        return template2rule[self.id]
 
-RuleTemplate()
 
-
-class Rule(ModelSQL, ModelView):
+class TaxRule(ModelSQL, ModelView):
     'Tax Rule'
-    _name = 'account.tax.rule'
-    _description = __doc__
+    __name__ = 'account.tax.rule'
     name = fields.Char('Name', required=True, translate=True)
     company = fields.Many2One('company.company', 'Company', required=True,
         select=True, domain=[
@@ -1023,85 +922,64 @@
     lines = fields.One2Many('account.tax.rule.line', 'rule', 'Lines')
     template = fields.Many2One('account.tax.rule.template', 'Template')
 
-    def apply(self, rule, tax, pattern):
+    def apply(self, tax, pattern):
         '''
         Apply rule on tax
-
-        :param rule: a rule id or the BrowseRecord of the rule
-        :param tax: a tax id or the BrowseRecord of the tax
-        :param pattern: a dictonary with rule line field as key
-                and match value as value
-        :return: a list of the tax id to use or None
+        pattern is a dictonary with rule line field as key and match value as
+        value.
+        Return a list of the tax id to use or None
         '''
-        tax_obj = Pool().get('account.tax')
-        rule_line_obj = Pool().get('account.tax.rule.line')
-
-        if isinstance(rule, (int, long)) and rule:
-            rule = self.browse(rule)
-
-        if isinstance(tax, (int, long)) and tax:
-            tax = tax_obj.browse(tax)
-
         pattern = pattern.copy()
         pattern['group'] = tax and tax.group.id or None
         pattern['origin_tax'] = tax and tax.id or None
 
-        for line in rule.lines:
-            if rule_line_obj.match(line, pattern):
-                return rule_line_obj.get_taxes(line)
+        for line in self.lines:
+            if line.match(pattern):
+                return line.get_taxes()
         return tax and [tax.id] or None
 
-    def update_rule(self, rule, template2rule=None):
+    def update_rule(self, template2rule=None):
         '''
         Update tax rule based on template.
-
-        :param rule: a rule id or the BrowseRecord of the rule
-        :param template2rule: a dictionary with tax rule template id as key
-                and tax rule id as value, used to convert template id into
-                tax rule. The dictionary is filled with new tax rules
+        template2rule is a dictionary with tax rule template id as key and tax
+        rule id as value, used to convert template id into tax rule. The
+        dictionary is filled with new tax rules.
         '''
-        template_obj = Pool().get('account.tax.rule.template')
-        lang_obj = Pool().get('ir.lang')
+        Lang = Pool().get('ir.lang')
 
         if template2rule is None:
             template2rule = {}
 
-        if isinstance(rule, (int, long)):
-            rule = self.browse(rule)
+        if self.template:
+            vals = self.template._get_tax_rule_value(rule=self)
+            if vals:
+                self.write([self], vals)
 
-        if rule.template:
-            vals = template_obj._get_tax_rule_value(rule.template, rule=rule)
-            if vals:
-                self.write(rule.id, vals)
-
-            prev_lang = rule._context.get('language') or CONFIG['language']
+            prev_lang = self._context.get('language') or CONFIG['language']
             prev_data = {}
-            for field_name, field in rule.template._columns.iteritems():
+            for field_name, field in self.template._fields.iteritems():
                 if getattr(field, 'translate', False):
-                    prev_data[field_name] = rule.template[field_name]
-            for lang in lang_obj.get_translatable_languages():
+                    prev_data[field_name] = getattr(self.template, field_name)
+            for lang in Lang.get_translatable_languages():
                 if lang == prev_lang:
                     continue
-                rule.setLang(lang)
-                data = {}
-                for field_name, field in rule.template._columns.iteritems():
-                    if (getattr(field, 'translate', False)
-                            and rule.template[field_name] !=
-                            prev_data[field_name]):
-                        data[field_name] = rule.template[field_name]
-                if data:
-                    with Transaction().set_context(language=lang):
-                        self.write(rule.id, data)
-            rule.setLang(prev_lang)
+                with Transaction().set_context(language=lang):
+                    rule = self.__class__(self.id)
+                    data = {}
+                    for field_name, field in rule.template._fields.iteritems():
+                        if (getattr(field, 'translate', False)
+                                and (getattr(rule.template, field_name)
+                                    != prev_data[field_name])):
+                            data[field_name] = getattr(rule.template,
+                                field_name)
+                    if data:
+                        self.write([rule], data)
             template2rule[rule.template.id] = rule.id
 
-Rule()
 
-
-class RuleLineTemplate(ModelSQL, ModelView):
+class TaxRuleLineTemplate(ModelSQL, ModelView):
     'Tax Rule Line Template'
-    _name = 'account.tax.rule.line.template'
-    _description = __doc__
+    __name__ = 'account.tax.rule.line.template'
     rule = fields.Many2One('account.tax.rule.template', 'Rule', required=True,
             ondelete='CASCADE')
     group = fields.Many2One('account.tax.group', 'Tax Group')
